package com.upyuns.platform.rs.website.biz;


import com.alibaba.fastjson.JSONObject;
import com.github.wxiaoqi.security.common.biz.BaseBiz;
import com.github.wxiaoqi.security.common.msg.ObjectRestResponse;
import com.upyuns.platform.rs.website.entity.ApiCustomNode;
import com.upyuns.platform.rs.website.entity.ApiCustomParams;
import com.upyuns.platform.rs.website.entity.ApiDoc;
import com.upyuns.platform.rs.website.mapper.ApiCustomNodeMapper;

import com.upyuns.platform.rs.website.mapper.ApiCustomParamsMapper;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import tk.mybatis.mapper.entity.Example;

import javax.annotation.Resource;
import java.util.Objects;

/**
 *
 */
@Service
public class ApiCustomNodeBiz extends BaseBiz<ApiCustomNodeMapper, ApiCustomNode> {


    @Autowired
    private ApiDocBiz apiDocBiz;

    @Resource
    private ApiCustomParamsMapper apiCustomParamsMapper;

    public ObjectRestResponse getListByAPiDocId(Integer id) {
        ApiDoc apiDoc = apiDocBiz.selectById(id);
        if (apiDoc == null || Objects.equals(apiDoc.getIsDel(),1)) {
            return ObjectRestResponse.succ("文档不存在");
        }
        Example example = new Example(ApiCustomNode.class);
        example.createCriteria()
                .andEqualTo("docId",apiDoc.getId())
                .andEqualTo("isDel", 0);
        example.setOrderByClause("seq_no desc");
        example.excludeProperties("respondJson");
        return ObjectRestResponse.succ(mapper.selectByExample(example));
    }

    public ObjectRestResponse getListById(Integer id) {
        Example exampleNode = new Example(ApiCustomNode.class);
        exampleNode.createCriteria()
                .andEqualTo("id",id)
                .andEqualTo("isDel",0);
        ApiCustomNode node = mapper.selectOneByExample(exampleNode);
        Example exampleParams = new Example(ApiCustomParams.class);
        exampleParams.createCriteria()
                .andEqualTo("docId",node.getDocId())
                .andEqualTo("isDel",0)
                .andEqualTo("nodeId",node.getId());
        ApiCustomParams apiCustomParams = apiCustomParamsMapper.selectOneByExample(exampleParams);
        JSONObject result = new JSONObject();
        result.put("apiInfo",node);
        result.put("apiUrlInfo",apiCustomParams);
        return ObjectRestResponse.succ(result);
    }
}




